complexType "ccmsk:RouterParams"

Namespace: | http://www.iro.umontreal.ca/lecuyer/contactcenters/msk
Content: | complex, 12 attributes, 17 elements
Defined: | globally in ccmsk.xsd, see XML source
Includes: | definitions of 12 attributes and 17 elements
Used: | at 1 location

XML Representation Summary
<...
| agentSelectionScore | = | ("WEIGHTONLY" | "NUMFREEAGENTS" | "LONGESTIDLETIME") : "LONGESTIDLETIME"
| allowCopies | = | xsd:boolean : "true"
| contactSelectionScore | = | ("WEIGHTONLY" | "QUEUESIZE" | "LONGESTWAITINGTIME") : "LONGESTWAITINGTIME"
| localSpecOverflowDelay | = | xsd:duration : "PT0S"
| longestWaitingTime | = | xsd:boolean : "true"
| numTestingPeriods | = | xsd:int
| overflowTransfer | = | xsd:boolean : "false"
| queueSizeThresh | = | xsd:int
| randomizedAgentSelection | = | xsd:boolean : "false"
| randomizedContactSelection | = | xsd:boolean : "false"
| routerPolicy | = | xsd:string
| testingPeriodDuration | = | xsd:duration
| >
Content: | properties?, typeToGroupMap?, groupToTypeMap?, ranksTG?, ranksGT?, ranksGTUpdate*, weightsTG?, weightsGT?, delaysGT?, incidenceMatrixTG?, incidenceMatrixGT?, queueWeights?, skillCounts?, targetFracAgents?, targetQueueRatio?, routingTableSources?, callTypeRouting*
</...>

Content Elements (17):

  callTypeRouting (type ccmsk:CallTypeRoutingParams), delaysGT (type ssj:NonNegativeDurationArray), groupToTypeMap (type ssj:IntArray), incidenceMatrixGT (type ssj:BooleanArray), incidenceMatrixTG (type ssj:BooleanArray), properties (type ssj:PropertiesParams), queueWeights (type ssj:nonNegativeDoubleList), ranksGT (type ssj:DoubleArray), ranksGTUpdate (type ccmsk:DoubleArrayWithMinWaitingTime), | ranksTG (type ssj:DoubleArray), routingTableSources (type ccmsk:RoutingTableSources), skillCounts (type ssj:nonNegativeIntList), targetFracAgents (type ssj:double01iList), targetQueueRatio (type ssj:nonNegativeDoubleList), typeToGroupMap (type ssj:IntArray), weightsGT (type ssj:DoubleArray), weightsTG (type ssj:DoubleArray)

All Direct / Indirect Based Elements (1):

  router (type ccmsk:RouterParams) |

Known Usage Locations

- As direct type of elements (1):

  router (type ccmsk:RouterParams) |

Annotation
Represents the router's parameters for a blend/multi-skill call center. The `routerPolicy` attribute, which gives the name of the routing policy, is the only element being always required for the router's parameters. However, depending on the selected policy, some other parameters become mandatory. For example, to use queue priority, one needs at least a type-to-group or a group-to-type maps. Parameters not used by the selected routing policy are ignored.
XML Source (w/o annotations (30); see schema source)

<xsd:complexType name="RouterParams"> <xsd:sequence> <xsd:element maxOccurs="1" minOccurs="0" name="properties" type="ssj:PropertiesParams"> <xsd:key name="UniquePropertyName"> <xsd:selector xpath="*"/> <xsd:field xpath="@name"/> </xsd:key> </xsd:element> <xsd:element minOccurs="0" name="typeToGroupMap" type="ssj:IntArray"> </xsd:element> <xsd:element minOccurs="0" name="groupToTypeMap" type="ssj:IntArray"> </xsd:element> <xsd:element minOccurs="0" name="ranksTG" type="ssj:DoubleArray"> </xsd:element> <xsd:element minOccurs="0" name="ranksGT" type="ssj:DoubleArray"> </xsd:element> <xsd:element maxOccurs="unbounded" minOccurs="0" name="ranksGTUpdate" type="ccmsk:DoubleArrayWithMinWaitingTime"> </xsd:element> <xsd:element minOccurs="0" name="weightsTG" type="ssj:DoubleArray"> </xsd:element> <xsd:element minOccurs="0" name="weightsGT" type="ssj:DoubleArray"> </xsd:element> <xsd:element minOccurs="0" name="delaysGT" type="ssj:NonNegativeDurationArray"> </xsd:element> <xsd:element minOccurs="0" name="incidenceMatrixTG" type="ssj:BooleanArray"> </xsd:element> <xsd:element minOccurs="0" name="incidenceMatrixGT" type="ssj:BooleanArray"> </xsd:element> <xsd:element minOccurs="0" name="queueWeights" type="ssj:nonNegativeDoubleList"> </xsd:element> <xsd:element minOccurs="0" name="skillCounts" type="ssj:nonNegativeIntList"> </xsd:element> <xsd:element minOccurs="0" name="targetFracAgents" type="ssj:double01iList"> </xsd:element> <xsd:element minOccurs="0" name="targetQueueRatio" type="ssj:nonNegativeDoubleList"> </xsd:element> <xsd:element minOccurs="0" name="routingTableSources" type="ccmsk:RoutingTableSources"> </xsd:element> <xsd:element maxOccurs="unbounded" minOccurs="0" name="callTypeRouting" type="ccmsk:CallTypeRoutingParams"> </xsd:element> </xsd:sequence> <xsd:attribute name="routerPolicy" type="xsd:string"> </xsd:attribute> <xsd:attribute default="PT0S" name="localSpecOverflowDelay" type="ssj:nonNegativeDuration"> </xsd:attribute> <xsd:attribute default="false" name="overflowTransfer" type="xsd:boolean"> </xsd:attribute> <xsd:attribute default="true" name="longestWaitingTime" type="xsd:boolean"> </xsd:attribute> <xsd:attribute name="numTestingPeriods" type="ssj:nonNegativeInt"> </xsd:attribute> <xsd:attribute name="testingPeriodDuration" type="ssj:nonNegativeDuration"> </xsd:attribute> <xsd:attribute name="queueSizeThresh" type="ssj:nonNegativeInt"> </xsd:attribute> <xsd:attribute default="true" name="allowCopies" type="xsd:boolean"> </xsd:attribute> <xsd:attribute default="false" name="randomizedAgentSelection" type="xsd:boolean"> </xsd:attribute> <xsd:attribute default="false" name="randomizedContactSelection" type="xsd:boolean"> </xsd:attribute> <xsd:attribute default="LONGESTIDLETIME" name="agentSelectionScore" type="ccmsk:AgentSelectionScore"> </xsd:attribute> <xsd:attribute default="LONGESTWAITINGTIME" name="contactSelectionScore" type="ccmsk:ContactSelectionScore"> </xsd:attribute> </xsd:complexType>

Attribute Detail
agentSelectionScore

  Determines how scores for agent selection are computed. This score is used only for policies based on agents' preferences.

  Type: | ccmsk:AgentSelectionScore
  Use: | optional
  Default: | "LONGESTIDLETIME"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="LONGESTIDLETIME" name="agentSelectionScore" type="ccmsk:AgentSelectionScore"> </xsd:attribute>

allowCopies

  Determines if contacts can be sent to multiple waiting queues. This boolean indicator is used by the queue-ratio overflow policy only.

  Type: | xsd:boolean
  Use: | optional
  Default: | "true"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="true" name="allowCopies" type="xsd:boolean"> </xsd:attribute>

contactSelectionScore

  Determines how scores for contact selection are computed. This score is used only for policies based on agents' preferences.

  Type: | ccmsk:ContactSelectionScore
  Use: | optional
  Default: | "LONGESTWAITINGTIME"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="LONGESTWAITINGTIME" name="contactSelectionScore" type="ccmsk:ContactSelectionScore"> </xsd:attribute>

localSpecOverflowDelay

  Determines the overflow delay used by the local-specialist routing policy, the default value being 0. This time duration is ignored by any routing policy, except local-specialist.

  Type: | ssj:nonNegativeDuration
  Use: | optional
  Default: | "PT0S"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="PT0S" name="localSpecOverflowDelay" type="ssj:nonNegativeDuration"> </xsd:attribute>

longestWaitingTime

  Determines if the agents' preference-based router with delays uses a single-pass agent selection based on the longest waiting time rather than multiple-passes selection giving priority to calls with minimal delays. This attribute has no effect if the router's policy is not agents' preference-based with delays. See the documentation of the agents' preference-based policy with delays for more information about this option.

  Type: | xsd:boolean
  Use: | optional
  Default: | "true"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="true" name="longestWaitingTime" type="xsd:boolean"> </xsd:attribute>

numTestingPeriods

  Determines the number of testing periods for routing policies basing their decisions on the system state during a certain time in the past. This element is not used by any routing policy in the current version of the simulator.

  Type: | ssj:nonNegativeInt
  Use: | optional
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute name="numTestingPeriods" type="ssj:nonNegativeInt"> </xsd:attribute>

overflowTransfer

  Determines the status of the overflow transfer mode used by the agents' preference-based router with delays, or the queue-ratio overflow router. This attribute has no effect if the router's policy is not agents' preference-based with delays or queue-ratio overflow. See the documentation of these policies for more information about this mode.

  Type: | xsd:boolean
  Use: | optional
  Default: | "false"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="false" name="overflowTransfer" type="xsd:boolean"> </xsd:attribute>

queueSizeThresh

  Determines the threshold on the queue size used by certain routing policies. This element is not used by any routing policy in the current version of the simulator.

  Type: | ssj:nonNegativeInt
  Use: | optional
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute name="queueSizeThresh" type="ssj:nonNegativeInt"> </xsd:attribute>

randomizedAgentSelection

  Determines if the agent selection is randomized. This boolean attribute has no effect for routing policies other than agents' preference-based, agents' preference-based with delays, and local-specialists.

  Type: | xsd:boolean
  Use: | optional
  Default: | "false"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="false" name="randomizedAgentSelection" type="xsd:boolean"> </xsd:attribute>

randomizedContactSelection

  Determines if the contact selection is randomized. This boolean attribute has no effect for routing policies other than agents' preference-based, agents' preference-based with delays, and local-specialists.

  Type: | xsd:boolean
  Use: | optional
  Default: | "false"
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute default="false" name="randomizedContactSelection" type="xsd:boolean"> </xsd:attribute>

routerPolicy

  Determines the router's policy used by the call center. Any enum constant in the Java class `RouterPolicyType` from package `umontreal.iro.lecuyer.contactcenters.app` is accepted as a value for this attribute. Moreover, custom simulation programs or Java archives may define additional router's policies; see the `RouterFactory` class from package `umontreal.iro.lecuyer.contactcenters.msk.spi` for more information about this.

  Type: | xsd:string
  Use: | optional
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute name="routerPolicy" type="xsd:string"> </xsd:attribute>

testingPeriodDuration

  Determines the duration of testing periods for routing policies basing their decisions on the system state during a certain time in the past. This element is not used by any routing policy in the current version of the simulator.

  Type: | ssj:nonNegativeDuration
  Use: | optional
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:attribute name="testingPeriodDuration" type="ssj:nonNegativeDuration"> </xsd:attribute>

Content Element Detail
callTypeRouting

  Describes the routing logic used for a specific call type by the `OVERFLOWANDPRIORITY` routing policy. When the latter policy is used, the router needs an occurrence of this element for any call type in the model. The other policies ignore any occurrence of this element.

  Type: | ccmsk:CallTypeRoutingParams, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element maxOccurs="unbounded" minOccurs="0" name="callTypeRouting" type="ccmsk:CallTypeRoutingParams"> </xsd:element>

delaysGT

  Determines the matrix of delays giving, for each (agent group, contact type) pair, the minimal delay a contact of the corresponding type must wait to be accepted for possible service by an agent in the corresponding group. The matrix has a format similar to `ranksGT` with delays instead of ranks. This element is used only by the `AGENTSPREFWITHDELAYS` policy.

  Type: | ssj:NonNegativeDurationArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="delaysGT" type="ssj:NonNegativeDurationArray"> </xsd:element>

groupToTypeMap

  Determines the group-to-type map routing table. The usage of this 2D array of integers depends on the selected routing policy. Each row corresponds to an agent group, and contains an ordered list of call types.

  Type: | ssj:IntArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="groupToTypeMap" type="ssj:IntArray"> </xsd:element>

incidenceMatrixGT

  Determines the group-to-type incidence matrix for this router. This matrix of booleans has dimensions I x K and its element (i, k) is `true` if and only if contacts of type k can be routed to agents in group i during contact selection. This matrix is not used in the current routing policies, but other routing matrices can be produced from it with the help of the `routingTableSources` element.

  Type: | ssj:BooleanArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="incidenceMatrixGT" type="ssj:BooleanArray"> </xsd:element>

incidenceMatrixTG

  Determines the type-to-group incidence matrix for this router. This matrix of booleans has dimensions K x I and its element (k, i) is `true` if and only if new contacts of type k can be routed to agents in group i during agent selection. This matrix is not used in the current routing policies, but other routing matrices can be produced from it with the help of the `routingTableSources` element.

  Type: | ssj:BooleanArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="incidenceMatrixTG" type="ssj:BooleanArray"> </xsd:element>

properties

  Gives properties associated with the router. The current version of the simulator ignores these properties, but custom routing policies might use them.

  Type: | ssj:PropertiesParams, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element maxOccurs="1" minOccurs="0" name="properties" type="ssj:PropertiesParams"> <xsd:key name="UniquePropertyName"> <xsd:selector xpath="*"/> <xsd:field xpath="@name"/> </xsd:key> </xsd:element>

queueWeights

  Determines the weight of each waiting queue q attached to the router. This array of double-precision values is used by the longest weighted waiting time policy, and this policy assigns a waiting queue for each type of contact. The length of the given array must therefore correspond to the number of call types.

  Type: | ssj:nonNegativeDoubleList, simple content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="queueWeights" type="ssj:nonNegativeDoubleList"> </xsd:element>

ranksGT

  Determines the group-to-type matrix of ranks used for contact selection by some routing policies. This matrix has one row for each agent group, and one column for each call type. Element (i,k) of the matrix sets the priority agents in group i give to queued calls of type k. An infinite value indicates that no queued call of type k can be served by agents in group i becoming free.

  Type: | ssj:DoubleArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="ranksGT" type="ssj:DoubleArray"> </xsd:element>

ranksGTUpdate

  Determines the matrix of ranks used for contact selection by some routing policies, for contacts having waited at least the given minimal waiting time. Using one or more occurrences of this element in combination with the `ranksGT` element can be used to change priority over time with some routing policies. In the current version of the simulator, this element is used only by the `AGENTSPREFWITHDELAYS` policy.

  Type: | ccmsk:DoubleArrayWithMinWaitingTime, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element maxOccurs="unbounded" minOccurs="0" name="ranksGTUpdate" type="ccmsk:DoubleArrayWithMinWaitingTime"> </xsd:element>

ranksTG

  Determines the type-to-group matrix of ranks used for agent selection by some routing policies. This matrix has one row per call type and one column per agent group. Element (k,i) of the matrix sets the priority assigned to agents in group i by calls of type k. An infinite value indicates that no new call of type k can be sent to agents in group i.

  Type: | ssj:DoubleArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="ranksTG" type="ssj:DoubleArray"> </xsd:element>

routingTableSources

  Determines how missing routing tables are constructed from given information. If this element is omitted, an error occurs if the routing policy requires a missing routing table. Otherwise, the information is constructed according to the specified attributes. Note that the construction logic can detect cycles, so for example setting both `ranksTG` to `ranksGT` and `ranksGT` to `ranksTG` will result in an error rather than an infinite loop if no matrix of ranks is given.

  Type: | ccmsk:RoutingTableSources, empty content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="routingTableSources" type="ccmsk:RoutingTableSources"> </xsd:element>

skillCounts

  Determines the skill count for each agent group. If this vector is needed but unspecified, the skill count is obtained by checking the `skillCount` attributes of agent groups. If no such attribute exists, the skill count is inferred by counting the number of call types agents in the concerned group can serve.

  Type: | ssj:nonNegativeIntList, simple content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="skillCounts" type="ssj:nonNegativeIntList"> </xsd:element>

targetFracAgents

  Determines the desired fraction of the total number of agents in all groups that serve contacts of each type. If the total number of agents at time t is N(t), and n[k] is the element k of the returned array, the desired number of agents serving calls of type k is n[k]N(t). This element is not used by any routing policy in the current version of the simulator.

  Type: | ssj:double01iList, simple content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="targetFracAgents" type="ssj:double01iList"> </xsd:element>

targetQueueRatio

  Determines the target queue ratio used by queue-ratio overflow router. This element requires a number for each agent group in the model, since the queue-ratio routing policy assigns a waiting queue to each agent group.

  Type: | ssj:nonNegativeDoubleList, simple content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="targetQueueRatio" type="ssj:nonNegativeDoubleList"> </xsd:element>

typeToGroupMap

  Determines the type-to-group map routing table. The usage of this 2D array of integers depends on the selected routing policy. Each row corresponds to a call type, and contains an ordered list of agent groups.

  Type: | ssj:IntArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="typeToGroupMap" type="ssj:IntArray"> </xsd:element>

weightsGT

  Determines the group-to-type matrix of weights used for contact selection by some routing policies. This matrix has a format similar to `ranksGT` but gives weights instead of priorities.

  Type: | ssj:DoubleArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="weightsGT" type="ssj:DoubleArray"> </xsd:element>

weightsTG

  Determines the type-to-group matrix of weights used for agent selection by some routing policies. This matrix has a format similar to `ranksTG` but gives weights instead of priorities.

  Type: | ssj:DoubleArray, complex content
  Defined: | locally, within (this) ccmsk:RouterParams complexType

  XML Source (w/o annotations (1); see schema source)

  <xsd:element minOccurs="0" name="weightsTG" type="ssj:DoubleArray"> </xsd:element>

XML Schema documentation generated with DocFlex/XML (Kit) v1.6.8 DocFlex/XML (Kit) is a freeware edition of DocFlex/XML, which is a powerful template-driven documentation and report generator from any data stored in XML files. Based on an innovative technology developed by FILIGRIS WORKS, this new tool offers virtuoso data querying and formatting capabilities not found in anything else! Need to convert your XML data into a clear nice-looking documentation or reports? Web-ready hypertext HTML or printable MS Word / OpenOffice.org friendly RTF? DocFlex/XML may be a cheap, quick and effective solution exactly for this task! Have questions? Not sure how to use it? Just send us e-mail to contact@filigris.com and we are always happy to help you! See also our services at www.filigris.com